var AksharKhadi={};
var Utils={};
Utils.Path='';
var questionId=0,startTime=0,scoredMarks=0,totalMarks=90,resId;
AksharKhadi.gameName="Aksharkhadi_Marathi";

$(document).ready(function(){
	//Utils.Path=Android.getMediaPath('Aksharkhadi');
	$(".se-pre-con").fadeOut("slow");
	setTimeout(function(){
		AksharKhadi.setAllImages();
		AksharKhadi.init();
	},200);
});


AksharKhadi.setAllImages=function()
{
	$('#playGame').prop('src',Utils.Path+'Images/Aksharkhadi_Play.png');
	$('#home').prop('src',Utils.Path+'Images/Aksharkhadi_Home.png');
	$('#speaker').prop('src',Utils.Path+'Images/Aksharkhadi_Sound.png');
	$('#next').prop('src',Utils.Path+'Images/Aksharkhadi_Next.png');
	$('#logo').prop('src',Utils.Path+'Images/logo.png');
	$('#wrongimg1').prop('src',Utils.Path+'Images/Wrong_02.png');
	$('#wrongimg2').prop('src',Utils.Path+'Images/Wrong_01.png');
	$('#wrongImg').prop('src',Utils.Path+'Images/joker.png');
	$('#playAgain').prop('src',Utils.Path+'Images/Aksharkhadi_Play-Again.png');
};

AksharKhadi.init=function(){
	
	$('#playGame').text(AksharKhadi.hardCodeddata.play);
	$('#Flip,#title').hide();
	$('#coverPage').show();
	$('#background').css({'backgroundImage':'url('+Utils.Path+'Images/'+AksharKhadi.hardCodeddata['coverPage']+')'});
};

AksharKhadi.getGameDataAfterTimeOut=function()
{
	document.getElementById('playSound').src=Utils.Path+'sounds/ting.mp3';
	document.getElementById('playSound').play();
	AksharKhadi.getGameData();
	setTimeout(function(){
		AksharKhadi.showQuestions();
	},1000);
}

AksharKhadi.getGameData=function()
{
	AksharKhadi.gameOpened=false;
	scoredMarks=0;
	$('#background').css({'backgroundImage':'url('+Utils.Path+'Images/'+AksharKhadi.hardCodeddata['BG']+')'});
	$('#Flip').show();
	$('#coverPage').hide();
	$('#next,#homeDiv,#home,#speaker').show();
	$('#wrongimg1,#wrongimg2').hide();
	var randomIndex=0,tempArray=[];
	AksharKhadi.counter=0,AksharKhadi.correctAnswerCount=0;
	AksharKhadi.arrOfSelectedWords=[];
	$('.slide').addClass('clickable');
	$('.optionForFlip').css({'display':'block'});
	$('.clickable').css({'pointer-events': 'none'});
	$('.defaultImage').removeClass('flipIt');
	$('#lastGamePage,#divContainingFullImage').hide();
	$('#soundDiv,#homeDiv,#divContainingSplitImages').fadeIn('slow');
	AksharKhadi.arrOfSelectedWords=populate(AksharKhadi.wordsData,AksharKhadi.arrOfSelectedWords, 9);
	AksharKhadi.arrOfSelectedWords=shuffleArray(AksharKhadi.arrOfSelectedWords);
	AksharKhadi.tempArray=AksharKhadi.arrOfSelectedWords.slice();
	AksharKhadi.fillGrid();
	startAsses();

}

function populate(array1, array2, length)
{
	var randomIndex;
	while (array2.length !== length) 
	{
		randomIndex = Math.floor(Math.random()*array1.length);
		if($.inArray(array1[randomIndex],array2) === -1)
		array2.push(array1[randomIndex]);
	}
	return array2;
}

function shuffleArray(array)
{
	var i,j,temp;
	for (i = array.length - 1; i > 0; i--) 
	{
	    j = Math.floor(Math.random() * (i + 1));
	    temp = array[i];
	    array[i] = array[j];
	    array[j] = temp;
	}
	return array;
}

AksharKhadi.playSoundAgain=function()
{
	document.getElementById('playSound').play();
};

AksharKhadi.showQuestions=function(tempArray)
{
	var d=new Date();
	startTime=d.getDate()+"-"+(d.getMonth()+1)+"-"+d.getFullYear()+" "+d.getHours()+":"+d.getMinutes()+":"+d.getSeconds();
	AksharKhadi.randomQuestion=Math.floor(Math.random()*AksharKhadi.tempArray.length);
	document.getElementById('playSound').src=Utils.Path+'sounds/'+AksharKhadi.tempArray[AksharKhadi.randomQuestion]['sound'];
	$('#title').data('question',AksharKhadi.tempArray[AksharKhadi.randomQuestion]['word'].trim());
	questionId=AksharKhadi.tempArray[AksharKhadi.randomQuestion]['questionId'];
	
	document.getElementById('playSound').play();
	$('.clickable').css({'pointer-events': 'auto'});
}

AksharKhadi.fillGrid=function()
{
	var i=1,imagePath;
	AksharKhadi.randomImg=Math.floor(Math.random()*AksharKhadi.imageSet.length);
	for(var j=1;j<4;j++)
	{
		for(var k=0;k<3;k++)
		{
			AksharKhadi.randomQuestion=Math.floor(Math.random()*AksharKhadi.arrOfSelectedWords.length);
			$('#imgDiv'+(i-1)).data('answer',AksharKhadi.arrOfSelectedWords[AksharKhadi.randomQuestion]['word'].trim());
			imagePath=Utils.Path+''+AksharKhadi.imageSet[AksharKhadi.randomImg]['img'];
			$('#imgDiv'+(i-1)).data('backImg',imagePath+''+i+''+AksharKhadi.imageSet[AksharKhadi.randomImg]['type']);
			$('#imgDiv'+(i-1)).data('frontImg',Utils.Path+''+AksharKhadi.frontimageSet['img']+''+i+''+AksharKhadi.frontimageSet['type']);
			/*if(AksharKhadi.arrOfSelectedWords[AksharKhadi.randomQuestion]['img']=="none")
			{*/
				$('#option'+(i-1)).text(AksharKhadi.arrOfSelectedWords[AksharKhadi.randomQuestion]['word'].trim());
				$('#img'+j+'_'+k).hide();
			/*}
			else
			{
				$('#img'+j+'_'+k).prop('src','Images/'+AksharKhadi.arrOfSelectedWords[AksharKhadi.randomQuestion]['img']);
				$('#option'+(i-1)).hide();
			}*/
			i++;
			AksharKhadi.arrOfSelectedWords.splice(AksharKhadi.randomQuestion,1);
		}
	}	
}

AksharKhadi.checkAns=function(evt)
{
	var source,frontImg;
	AksharKhadi.gameOpened=true;
	AksharKhadi.counter++;
	$('.clickable').css({'pointer-events': 'none'});
	wrongImgArray=['backWrong1.png','backWrong2.png'];
	if($('#'+evt).data('answer')==$('#title').data('question'))
	{
		AksharKhadi.correctAnswerCount++;
		$('#'+evt).find('img').show();
		$('#'+evt).find('p').hide();
		$('#'+evt).removeClass('clickable');
		source=$('#'+evt).data('backImg');
		frontImg=$('#'+evt).data('frontImg');
		$('#'+evt).find('img').prop('src',frontImg);
		document.getElementById('playSound').src=Utils.Path+'sounds/CorrectAksharkhadi.mp3';
		document.getElementById('playSound').play();
		scoredMarks+=10;
		setTimeout(function(){
			$('#'+evt).find('img').prop('src',source);
			$('#'+evt).find('img').addClass('flipIt');
		},900);
	}	
	else
	{
		scoredMarks+=0;
		$('#'+evt).addClass("shake");
		randomImg=Math.floor(Math.random()*wrongImgArray.length);
		$('#wrongimg1,#wrongimg2').show();
		document.getElementById('playSound').src=Utils.Path+'sounds/wrongSoundAksharkhadi.mp3';
		document.getElementById('playSound').play();
		for(var i=0;i<9;i++)
		{
			if($('#title').data('question')==$('#imgDiv'+i).data('answer'))
			{
				var offsetOfImage=$('#imgDiv'+i).offset();
				break;
			}
		}

		$('#imgDiv'+i).find('img').prop('src',Utils.Path+'Images/'+wrongImgArray[randomImg]);
		$('#imgDiv'+i).find('img').show();
		$('#imgDiv'+i).find('p').hide();
		setTimeout(function(){
				$('#'+evt).removeClass("shake");
				$('#wrongimg1,#wrongimg2').hide();
			},900);
	}
	AksharKhadi.tempArray.splice(AksharKhadi.randomQuestion,1);
	if(AksharKhadi.nextQuestionTimer)
	{
				clearTimeout(AksharKhadi.nextQuestionTimer);
				AksharKhadi.nextQuestionTimer = null;
	}
	AksharKhadi.nextQuestionTimer=setTimeout(function()
	{
		if(AksharKhadi.counter<9)
		{	
			AksharKhadi.showQuestions();
			$('.clickable').css({'pointer-events': 'auto'});
		}
		else
		{
			$('.clickable').css({'pointer-events': 'none'});
			console.log(resId,questionId,scoredMarks,totalMarks,1,startTime);
			//Android.addScore(resId,questionId,scoredMarks,totalMarks,1,startTime);
			endAssess(scoredMarks,questionId);
			AksharKhadi.gameOpened=false;
			if(AksharKhadi.correctAnswerCount>8)
			{
				$('#divContainingSplitImages').fadeOut(500);
				
				setTimeout(function()
				{
					$('#soundDiv,#homeDiv').hide();
					$('#div3').removeClass('col-xs-10 col-sm-10 col-md-10 col-lg-10');
					$('#div3').addClass('col-xs-8 col-sm-8 col-md-8 col-lg-8 ');
					$('#fullImage').prop('src',Utils.Path+''+AksharKhadi.imageSet[AksharKhadi.randomImg]['completeImg']);
					$('#divContainingFullImage').fadeIn(500);
					document.getElementById('playSound').src=Utils.Path+'sounds/Bell.mp3';
					document.getElementById('playSound').play();
					$('#next,#homeDiv,#home').show();
					$('#speaker').hide();
					setTimeout(function()
					{
						$('#next').addClass('blink_me');
					},2500);
				},500);
			}
			else
			{
				document.getElementById('playSound').src=Utils.Path+'sounds/soundForWrong.mp3';
				document.getElementById('playSound').play();
				$('#divContainingSplitImages').fadeOut(500);
				setTimeout(function()
				{					
					$('#myModal').fadeIn(500);
					$('#soundDiv,#homeDiv').hide();
				},500);
			}
		}
	},2000);	
}

AksharKhadi.showNextQuestion=function()
{
	clearTimeout(AksharKhadi.nextQuestionTimer);
	if(AksharKhadi.gameOpened==true)
	{
		console.log(resId,questionId,scoredMarks,totalMarks,1,startTime);
		endAssess(scoredMarks,questionId);
		//Android.addScore(resId,questionId,scoredMarks,totalMarks,1,startTime);
	}
	
		$('#myModal').removeClass('magictime vanishIn');
		$("#myModal").fadeOut('slow');
		$('#next').removeClass('blink_me');
		$('#div3').removeClass('col-xs-8 col-sm-8 col-md-8 col-lg-8 ');
		$('#div3').addClass('col-xs-10 col-sm-10 col-md-10 col-lg-10');
		AksharKhadi.getGameData();
		AksharKhadi.showQuestions();
};

AksharKhadi.callHome=function()
{
	clearTimeout(AksharKhadi.nextQuestionTimer);
	if(AksharKhadi.gameOpened==true)
	{
		console.log(resId,questionId,scoredMarks,totalMarks,1,startTime);
		//Android.addScore(resId,questionId,scoredMarks,totalMarks,1,startTime);
				endAssess(scoredMarks,questionId);
	}
	setTimeout(function(){
		location.reload(true);
	},200);
}